<?php
/***************************************************************************
 * $Id: importgui.php 56 2008-06-08 22:35:41Z Nico $
 * Part of Parsimony Import
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

session_start();

include_once ( 'phpbb2.class.php' );
include_once ( 'phpbb3.class.php' );
include_once ( 'smf1.class.php' );
include_once ( 'mybb1.class.php' );
include_once ( 'xajax/xajax_core/xajaxAIO.inc.php' );

$xajax = new xajax();
$xajax->configure('javascript URI', 'xajax');
$xajax->configure('debug', false );

function initImport ( $data ) {
	extract ( $data );
	
	$debug = ( $debug == "true" );

	switch ( $importTo ) {
		case 'phpBB2':
			$importKlasse = new phpBB2Import( $ordner, $host, $user, $password, $database, $forumID, $prefix, true, $debug );
			break;
		case 'phpBB3':
			$importKlasse = new phpBB3Import( $ordner, $host, $user, $password, $database, $forumID, $prefix, true, $debug );
			break;
		case 'SMF1':
			$importKlasse = new SMF1Import( $ordner, $host, $user, $password, $database, $forumID, $prefix, true, $debug );
			break;
		case 'MyBB1':
			$importKlasse = new myBB1Import( $ordner, $host, $user, $password, $database, $forumID, $prefix, true, $debug );
			break;			
		default:
			die ( 'Unknown destination ' . $importTo );		
	}
	
	if ( $importKlasse->hasAlert() ) {
		return $importKlasse->getResponse();
	}
	
	if ( $debug && $truncate == "true" ) {
		$importKlasse->prepareForDebug();
	}

	if ( $importKlasse->hasAlert() ) {
		return $importKlasse->getAlert();
	}
	
	$_SESSION['importKlasse'] = serialize($importKlasse);
	$_SESSION['lastProgress'] = array(-1,'');
	
	$response = new xajaxResponse();
	$response->script("document.importForm.startButton.disabled=true;");
	$response->script('document.importForm.startButton.value="Bitte warten!";');
	
	$response->script("xajax_doImport();");
	
	return $response;
}

function doImport ( ) {
	if ( !isset ($_SESSION['importKlasse'] ) ) {
		$answer = new xajaxResponse();
		$answer->alert('Error on reinitialization!' );
		return $answer;
	}
	
	$importKlasse = unserialize($_SESSION['importKlasse']); 
	
	$importKlasse->importPostings ( 30 );

	if ( $importKlasse->hasAlert() ) {
		return $importKlasse->getAlert();
	}
	
	$response = new xajaxResponse();
	$output = $importKlasse->outputProgress();
	if ( $output[1] != $_SESSION['lastProgress'][1] ) {
		//$response->alert($output[1]);
		$response->assign('progressBar', 'innerHTML', $output[1] );
		$_SESSION['lastProgress'] = $output;
	}
	if ( !$importKlasse->everythingDone() ) {
		$response->script("xajax_doImport();");
	} else {
		$finallyResponse = $importKlasse->finally();
		$response->assign('progressBar', 'innerHTML', 'alles erledigt! - ' . $finallyResponse );
	}
	$_SESSION['importKlasse'] = serialize($importKlasse);
	
	return $response;
}

$xajax->registerFunction('initImport');
$xajax->registerFunction('doImport');

$xajax->processRequest();
?>

<html><head>
<title>Parsimony-Importer</title>
</head><body>

<?php $xajax->printJavascript(); ?>

<script type="text/javascript">
function startImport() {
	xajax_initImport(xajax.getFormValues('importForm'));
}
</script>

<form id = "importForm" name = "importForm">
<table>
<tr><td>Importieren in:</td><td><select name = "importTo">
<option value = "phpBB2">phpBB2</option>
<option value = "phpBB3">phpBB3</option>
<option value = "SMF1">Simple Machines Forum 1.x</option>
<option value = "MyBB1" selected>MyBB 1.x</option>
</select></td></tr>
<tr><td>Quellordner:</td><td><input type = "text" name = "ordner" value = "c:\parsimony\"></td></tr>
<tr><td>Datenbank-Host:</td><td><input type = "text" name = "host" value = "localhost"></td></tr>
<tr><td>Datenbank-User:</td><td><input type = "text" name = "user" value = "phpbb"></td></tr>
<tr><td>Datenbank-Passwort:</td><td><input type = "text" name = "password" value = "phpbb"></td></tr>
<tr><td>Datenbank des Forums:</td><td><input type = "text" name = "database" value = "phpbb"></td></tr>
<tr><td>Foren-Prfix:</td><td><input type = "text" name = "prefix" value = "phpbb_"></td></tr>
<tr><td>Foren-ID:</td><td><input type = "text" name = "forumID" value = "2"></td></tr>
<tr><td>Tabellen leeren vor dem Start (<b>nicht</b> empfohlen!)</td><td><input type = "radio" name = "truncate" value = "false" checked> Nein /
<input type = "radio" name = "truncate" value = "true"> Ja</td></tr>
<tr><td>Debug-Modus:</td><td><input type = "radio" name = "debug" value = "false" checked> Nein /
<input type = "radio" name = "debug" value = "true"> Ja</td></tr>
<tr><td colspan = 2><input type = "button" name = "startButton" value = "Starten!" onclick="startImport();"></td></tr>
</table>
</form>

<div id = "progressBar"></div>

</body></html>
