<?php
/***************************************************************************
 * $Id: phpbb-basis.class.php 56 2008-06-08 22:35:41Z Nico $
 * Part of Parsimony Import
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

include_once 'basis.class.php';

class phpBBBasisImport extends basisImport {
	
	var $forumID = null;
	var $topicsAdded = array();
	var $prefix = '';

	function phpBBBasisImport ( $directory, $host, $user, $pass, $db, $forumID, $prefix = 'phpbb_', $useXAJAX = false, $debug = false ) {
		$this->basisImport( $directory, $host, $user, $pass, $db, $useXAJAX, $debug );	
		$this->forumID = (int)$forumID;
		$this->prefix = $prefix;
		
		if ( $this->hasAlert() ) {
			return;
		}		
		
		// Check if tables exist
		$this->checkTableExistance( $this->prefix . 'forums' );
		$this->checkTableExistance( $this->prefix . 'topics' );
		$this->checkTableExistance( $this->prefix . 'posts' );

		if ( $this->hasAlert() ) {
			return;
		}	
		
		// Check if forumID is valid	
		if ( $this->forumID == null ) {
			$this->alert ( 'Please set a forumID before starting the import!' );
			return;
		}
		
		$sql = 'SELECT * FROM `' . $this->prefix . 'forums` WHERE forum_id = ' . $this->forumID;
		if ( $this->database->sql_numrows ( $this->database->sql_query ( $sql ) ) != 1 ) {
			$this->alert ( 'Cannot add imported postings to a unknown forum' );
			return;
		}
	}
	
	function insertNewTopic ( $title, $posterName, $time ) {
		$this->alert ( "Error! Your plugin does not provide it's own insertPosting-function!" );
	}
	
	function insertPosting ( $topicID, $posterName, $title, $text, $time ) {
		$this->alert ( "Error! Your plugin does not provide it's own insertPosting-function!" );
	}
	
	function generateBB ( $text ) {
		$text = $this->generateQuote( $text, 'quote:' . $this->bbCodeUID , 'quote:' . $this->bbCodeUID );
		$text = preg_replace ( "@&amp;lt;i&amp;gt;(.*?)&amp;lt;/i&amp;gt;@s", "[i:" . $this->bbCodeUID . "]$1[/i:" . $this->bbCodeUID . "]", $text );
		
		$text = str_replace ( array ( "&amp;lt;", "&amp;gt;" ), array ( "&lt;", "&gt;" ), $text );
		return $text;
	}
}
?>